VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4035
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   5820
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4035
   ScaleWidth      =   5820
   Begin VB.CommandButton cmdBuild 
      Caption         =   "Build"
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtCols 
      Height          =   285
      Left            =   840
      TabIndex        =   6
      Text            =   "10"
      Top             =   600
      Width           =   495
   End
   Begin VB.TextBox txtRows 
      Height          =   285
      Left            =   840
      TabIndex        =   5
      Text            =   "5"
      Top             =   240
      Width           =   495
   End
   Begin VB.CommandButton cmdRandomize 
      Caption         =   "Randomize"
      Height          =   375
      Left            =   1560
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Columns"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   630
      Width           =   600
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Rows"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   270
      Width           =   405
   End
   Begin VB.Label lblNumber 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Visible         =   0   'False
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Max1 As Integer
Private Max2 As Integer

Private Numbers() As Integer

Private Sub BuildArray()
Dim i As Integer
Dim j As Integer

    ' Initialize the array with values
    ' from 1 to Max1 * Max2.
    ReDim Numbers(1 To Max1, 1 To Max2)
    For i = 1 To Max1
        For j = 1 To Max2
            Numbers(i, j) = (i - 1) * Max2 + j
        Next j
    Next i
End Sub

' Create the necessary label controls.
Private Sub LoadLabels()
Dim i As Integer
Dim j As Integer
Dim index As Integer
Dim X As Single
Dim Y As Single

    ' Load and position the labels.
    Y = lblNumber(0).Top
    index = 1
    For i = 1 To Max1
        X = lblNumber(0).Left
        For j = 1 To Max2
            If index > lblNumber.UBound _
                Then Load lblNumber(index)
            lblNumber(index).Move X, Y
            lblNumber(index).Visible = True
            X = X + lblNumber(0).Width + 60
            index = index + 1
        Next j
        Y = Y + lblNumber(0).Height + 60
    Next i

    ' Unload labels no longer needed.
    For i = lblNumber.UBound To index Step -1
        Unload lblNumber(i)
    Next i
End Sub

' Display the numbers.
Public Sub ShowNumbers()
Dim i As Integer
Dim j As Integer
Dim index As Integer

    index = 1
    For i = 1 To Max1
        For j = 1 To Max2
            lblNumber(index).Caption = Numbers(i, j)
            index = index + 1
        Next j
    Next i
End Sub

' Assumes the array should be dimensioned
' as in Numbers(1 To Max1, 1 To Max2).
Private Sub RandomizeArray()
Dim max_cell As Integer
Dim i1 As Integer
Dim j1 As Integer
Dim i2 As Integer
Dim j2 As Integer
Dim index1 As Integer
Dim index2 As Integer
Dim tmp As Integer

    ' Randomize the array.
    Randomize
    max_cell = Max1 * Max2
    For index1 = 1 To max_cell - 1
        ' Pick a random entry.
        index2 = Int((max_cell - index1 + 1) * Rnd + index1)

        ' Convert to 2-dimensional indexing.
        i1 = ((index1 - 1) \ Max2) + 1
        j1 = index1 - (i1 - 1) * Max2
        i2 = ((index2 - 1) \ Max2) + 1
        j2 = index2 - (i2 - 1) * Max2

        ' Swap the numbers.
        tmp = Numbers(i1, j1)
        Numbers(i1, j1) = Numbers(i2, j2)
        Numbers(i2, j2) = tmp
    Next index1
End Sub

Private Sub cmdBuild_Click()
    Max1 = CInt(txtRows.Text)
    Max2 = CInt(txtCols.Text)
    LoadLabels

    BuildArray
    ShowNumbers

    cmdRandomize.SetFocus
End Sub
Private Sub cmdRandomize_Click()
    RandomizeArray
    ShowNumbers
End Sub

